#include <Adafruit_NeoPixel.h>
#include <SoftwareSerial.h>
SoftwareSerial serial(2, 3); // RX | TX


//Pin zum steuern des Moduls ist am digitalen Pin D13 angeschlossen
#define PIN 13

const int MAX_PIXEL = 40; //das Modul verfügt über insgesamt 40 LEDs vom Typ 5050
Adafruit_NeoPixel strip = Adafruit_NeoPixel(MAX_PIXEL, PIN, NEO_GRB + NEO_KHZ800);

//Wenn alle Farben auf 0 sind dann ist die LED aus
const uint32_t COLOR_NONE = strip.Color(0, 0, 0);

String dataLine = "";

void setup() {
  Serial.begin(9600);
  serial.begin(9600);
  //begin der kommunikation mit dem Modul
  strip.begin();
  strip.setBrightness(15);
  strip.show();
}

void loop() {
  if (serial.available() > 0) {
    dataLine = serial.readString();
    dataLine.trim();
    if (dataLine.length() > 0 ) {     
      dataLine.replace("\r","");
      dataLine.replace("\n","");

      if(dataLine == "reset"){
        resetPixel();
        return;
      }
      
      int from = 0;
      int to = 12;
      for (int i = 0; i < dataLine.length() / 12; i++) {
        String line = dataLine.substring(from, (to+(i*12)));
        from = from + 12;       
        int pixelIndex = line.substring(0, 2).toInt();
        String rgbValue = line.substring(3);
        int red = rgbValue.substring(0, 3).toInt();
        int green = rgbValue.substring(3, 6).toInt();
        int blue = rgbValue.substring(6,10).toInt();
        pixel(pixelIndex, red, green, blue);
      }
    } else {
      Serial.print("Es wurde eine Zeile mit ");
      Serial.print(dataLine.length());
      Serial.print("Daten empfangen!");
    }
  }
}

void pixel(int pixel, int red, int green, int blue) {
  strip.setPixelColor(pixel, strip.Color(red, green, blue));
  strip.show();
}

void resetPixel(){
  for(int i=0;i<40;i++){
    strip.setPixelColor(i, COLOR_NONE);
  }
  strip.show();
}
